<?php

include "php/function.php";

error_reporting(E_ALL);
ini_set('display_errors', TRUE);
ini_set('display_startup_errors', TRUE);

if (isset($_GET['saga'])) {
	$sagaID = $_GET['saga'];

	$result = movie_list($sagaID);

	$movies_list = json_encode($result);

	$saga_name = saga_name($sagaID);

}
elseif (isset($_GET['movie'])) {
	$id = $_GET['movie'];

	$result = movie_detail($id);

	$result['release_date'] = ucwords(strftime("%d %B %Y", strtotime($result['release_date'])));

	$movie_detail = json_encode($result);

	$file = $result['file_path'];

	//$file = '/var/www/html/video/test5.mkv';

	if (is_file($file)) {

		$info = MediaInfo($file);

		$file_info = json_encode($info);
	}

}

	$saga_list = json_encode(saga_list());

	$movies_full_list = json_encode(movies_full_list());

?>

<!doctype html>
<html lang="fr">
<head>
	<meta charset="utf-8">
	<title>Netflix 2.0</title>
    <link href="style/style.css" rel="stylesheet">
    <link href="/fontawesome/css/all.css" rel="stylesheet" />
</head>
<body>
	<div class="navbar">
		<a href=".">Films</a>
		<a href="#anime">Animés</a>
		<input id="search" type="text" name="search" placeholder="Recherche">
		<i class="fa fa-list fa-2x" aria-hidden="true" title="Vue en liste"></i>
		<i class="fa fa-th fa-2x" aria-hidden="true" title="Vue en miniature"></i>
	</div>

	<h2 class="main">Netflix 2.0</h2>
	<div id="heure" style="margin: 0 10px; padding: 0;"></div>

	<div id="sagas" class="main" ></div>
	<div id="movies" class="main" ></div>
	<div id="research" class="main" ></div>

<?php
if (isset($movie_detail)):
?>
	<section id="movieContent" class="main">
		<h2 id="movieTitle" style="margin: 0;"></h2>
		<h3 id="showDetail" class="toggle"><i class="fa fa-chevron-down" aria-hidden="true"></i> Afficher détail</h3>
		<div id="movieDetails">
			<div id="cover" >
				<img width="300" src="">
			</div>
			<div id="spec">
				<p></p>
			</div>
		</div>
		<div id="selection">
			<div id="AV"></div>
			<div id="subtitle_list"></div>
		</div>
		<div class="hidden" id="video">
			<!--<video width="600" controls>
				<source src="" type="video/mp4">
			</video>-->
		</div>
	</section>
<?php
endif;
?>
	<br>
	<button id="back" onclick="goBack()">Go Back</button>
    
    <script>

	<?php 
	echo "var saga_list = " . $saga_list. ";\n";
	echo "var movies_full_list = " . $movies_full_list. ";\n";
	if (isset($movies_list)) echo "var movies_list = " . $movies_list. ";\nvar saga_name = '" . addslashes($saga_name). "';";
	if (isset($file_info)) echo "var file_info = " . $file_info. ';';
	if (isset($movie_detail)) echo "var movie_detail = " . $movie_detail. ';';
	?>
	
    </script>
    <script src="js/jquery-3.4.1.js"></script>
    <script src="js/function.js"></script>
    <script src="js/script.js"></script>
</body>
</html>
